|
||||||||||
| PREV CLASS NEXT CLASS | FRAMES NO FRAMES | |||||||||
| SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD | |||||||||
public interface IRequestCycle
Controller object that manages a single request cycle. A request cycle is one 'hit' on the web server. In the case of a Tapestry application, this will involve:
IEngineServiceobject
Mixed in with this is:
A request cycle is broken up into two phases. The rewind phase is optional, as it tied
to ActionLinkor Form
components. In the rewind phase, a previous page render is redone (discarding output) until a
specific component of the page is reached. This rewinding ensures that the page is restored to
the exact state it had when the URL for the request cycle was generated, taking into account the
dynamic nature of the page (Foreach,
Conditional, etc.). Once this component is reached, it
can notify its IActionListener. The listener has the ability to update the state of any
pages and select a new result page.
Following the rewind phase is the render phase. During the render phase, a page is actually rendered and output sent to the client web browser.
| Method Summary | |
|---|---|
void |
activate(IPage page)
Sets the active page for the request. |
void |
activate(java.lang.String name)
A convienience for invoking activate(IPage). |
void |
cleanup()
Invoked after the request cycle is no longer needed, to release any resources it may have. |
void |
commitPageChanges()
Invoked just before rendering the response page to get all page recorderstouched in this request cycle
to commit their changes (save them to persistant storage). |
java.lang.String |
encodeURL(java.lang.String URL)
Passes the String through HttpServletResponse.encodeURL(java.lang.String), which ensures
that the session id is encoded in the URL (if necessary). |
void |
forgetPage(java.lang.String name)
Forgets any stored changes to the specified page. |
java.lang.String |
getAbsoluteURL(java.lang.String partialURL)
Converts a partial URL into an absolute URL. |
java.lang.Object |
getAttribute(java.lang.String name)
Retrieves a previously stored attribute, returning null if not found. |
IEngine |
getEngine()
Returns the engine which is processing this request cycle. |
Infrastructure |
getInfrastructure()
Returns the central Infrastructure object used to
manage the processing of the request. |
java.lang.Object[] |
getListenerParameters()
Returns parameters previously stored by setListenerParameters(Object[]). |
java.lang.String |
getNextActionId()
Deprecated. To be removed in release 4.1 with no replacement. |
IPage |
getPage()
Identifies the active page, the page which will ultimately render the response. |
IPage |
getPage(java.lang.String name)
Returns the page with the given name. |
java.lang.String |
getParameter(java.lang.String name)
Returns a query parameter value, or null if not provided in the request. |
java.lang.String[] |
getParameters(java.lang.String name)
Returns all query parameter values for the given name. |
ResponseBuilder |
getResponseBuilder()
Entry point for getting the response builder used to build this response. |
IEngineService |
getService()
Returns the service which initiated this request cycle. |
java.lang.String |
getUniqueId(java.lang.String baseId)
Returns the provided string, possibly modified (with an appended suffix) to make it unique. |
boolean |
isRewinding()
Returns true if the context is being used to rewind a prior state of the page. |
boolean |
isRewound(IComponent component)
Checks to see if the current action id matches the target action id. |
void |
removeAttribute(java.lang.String name)
Removes a previously stored attribute, if one with the given name exists. |
void |
renderPage(ResponseBuilder builder)
Renders the given page. |
void |
rewindForm(IForm form)
Used by formsto perform a partial rewind so as to respond to the
form submission (using the direct service). |
void |
rewindPage(java.lang.String targetActionId,
IComponent targetComponent)
Deprecated. To be removed in 4.1 with no replacement. |
void |
sendRedirect(java.lang.String URL)
Sends a redirect to the client web browser. |
void |
setAttribute(java.lang.String name,
java.lang.Object value)
Allows a temporary object to be stored in the request cycle, which allows otherwise unrelated objects to communicate. |
void |
setListenerParameters(java.lang.Object[] parameters)
Invoked by a service to store an array of application-specific
parameters. |
void |
setResponseBuilder(ResponseBuilder builder)
Sets the ResponseBuilder to use for this response, don't
try setting this unless you're very sure you know what you are doing as
this isn't the only way that it is used. |
| Method Detail |
|---|
void cleanup()
java.lang.String encodeURL(java.lang.String URL)
HttpServletResponse.encodeURL(java.lang.String), which ensures
that the session id is encoded in the URL (if necessary).
IEngine getEngine()
java.lang.Object getAttribute(java.lang.String name)
java.lang.String getNextActionId()
getUniqueId(String)IPage getPage()
IPage getPage(java.lang.String name)
PageNotFoundException - if the page does not exist.org.apache.tapestry.engine.IPageSource#getPage(IRequestCycle, String, IMonitor)boolean isRewinding()
boolean isRewound(IComponent component)
If theres a match on action id, then the component is compared against the target component.
If there's a mismatch then a StaleLinkExceptionis thrown.
void setResponseBuilder(ResponseBuilder builder)
ResponseBuilder to use for this response, don't
try setting this unless you're very sure you know what you are doing as
this isn't the only way that it is used. (ie replacing this builder won't
necessarily override another builder being used already)
builder - The response builder that may be used by components
to help with delegate/sub component rendering.ResponseBuilder getResponseBuilder()
void removeAttribute(java.lang.String name)
void renderPage(ResponseBuilder builder)
IRender.render(IMarkupWriter, IRequestCycle)since the request
cycle must perform some setup before rendering.
void rewindPage(java.lang.String targetActionId,
IComponent targetComponent)
IAction,
ActionLink
void setAttribute(java.lang.String name,
java.lang.Object value)
HttpServletRequest.setAttribute(),
except that values can be changed and removed as well.
This is used by components to locate each other. A component, such as
Body, will write itself under a well-known name into the
request cycle, and components it wraps can locate it by that name.
Attributes are cleared at the end of each render or rewind phase.
void commitPageChanges()
page recorderstouched in this request cycle
to commit their changes (save them to persistant storage).
IPageRecorder.commit()IEngineService getService()
void rewindForm(IForm form)
formsto perform a partial rewind so as to respond to the
form submission (using the direct service).
Note: the targetActionId parameter was removed in release 4.0.
void setListenerParameters(java.lang.Object[] parameters)
service to store an array of application-specific
parameters. These can later be retrieved (typically, by an application-specific listener
method) by invoking getListenerParameters().
DirectServicejava.lang.Object[] getListenerParameters()
setListenerParameters(Object[]).
void activate(java.lang.String name)
activate(IPage). Invokes getPage(String)to
get an instance of the named page.
void activate(IPage page)
service.
Frequently, the active page is changed (from a listener method) to choose an alternate page
to render the response).
IPage.validate(IRequestCycle)is invoked on the page to be activated.
PageRedirectExceptionis caught and the page specified in the exception will be the
active page instead (that is, a page may "pass the baton" to another page using the
exception). The new page is also validated. This continues until a page does not throw
PageRedirectException.
Validation loops can occur, where page A redirects to page B and then page B redirects back
to page A (possibly with intermediate steps). This is detected and results in an
ApplicationRuntimeException.
java.lang.String getParameter(java.lang.String name)
java.lang.String[] getParameters(java.lang.String name)
java.lang.String getAbsoluteURL(java.lang.String partialURL)
request.
void forgetPage(java.lang.String name)
Infrastructure getInfrastructure()
Infrastructure object used to
manage the processing of the request.
java.lang.String getUniqueId(java.lang.String baseId)
baseId - the base id from which to generate the unique string.
void sendRedirect(java.lang.String URL)
RedirectException, but may change in a later release.
RedirectException
|
||||||||||
| PREV CLASS NEXT CLASS | FRAMES NO FRAMES | |||||||||
| SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD | |||||||||